(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.haypo.fr.st/ $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                                                                            
    Programmme de test de la souris avec possibilit de changer le curseur  
 et la sensibilit.                                                         
*)

{$M 4096,0,0}
{$G+}

uses Clavier,DrvSouri,EcranVga,StopProg;

const
  CoulFond = 3;

  OuiNon : array[0..1] of string[4] = ('      ','Clic');

  NouvCur : array[0..2] of Cur16x16x1 = (
    { Carre vide }
    (Donnee:(    0, $7FFE, $7FFE, $7FFE, $7FFE, $7FFE, $7FFE, $7FFE,
             $7FFE, $7FFE, $7FFE, $7FFE, $7FFE, $7FFE, $7FFE,      0);

     Masque:($FFFF, $8001, $8001, $8001, $8001, $8001, $8001, $8001,
             $8001, $8001, $8001, $8001, $8001, $8001, $8001, $FFFF)),

    { Carreaux }
    (Donnee:($5555, $AAAA, $5555, $AAAA, $5555, $AAAA, $5555, $AAAA,
             $5555, $AAAA, $5555, $AAAA, $5555, $AAAA, $5555, $AAAA);
     Masque:($AAAA, $5555, $AAAA, $5555, $AAAA, $5555, $AAAA, $5555,
             $AAAA, $5555, $AAAA, $5555, $AAAA, $5555, $AAAA, $5555)),


  { Vivi }
    (Donnee:($77FF, $77FF, $77FF, $75FF, $77FF, $ADFF, $DDFF, $FD77,
             $FD77, $FD75, $FF77, $FF75, $FFAD, $FFDD, $FFFD, $FFFD);
     Masque:($8800, $8800, $8800 ,$8A00, $8800, $5200, $2200, $0288,
             $0288, $028A ,$0088 ,$008A, $0052, $0022, $0002, $0002)));

var
  SensibiliteSouris: Byte;
  SeuilAccelSouris: Byte;

  txt: string;
  CurActif: byte;
  key: char;

procedure ChangeSensibilite (Plus: integer); begin
  with Souris do begin
    Plus := SensibiliteSouris +Plus;
    if Plus<0   then Plus := 0;
    if 100<Plus then Plus := 100;
    SensibiliteSouris := Plus;

    ChangeSensibiliteSouris (SensibiliteSouris,SensibiliteSouris,SeuilAccelSouris);
    str (SensibiliteSouris:3,txt);
    EcriVga (8*14,8*5,txt,14,CoulFond);
  end;
end;

procedure ActuSouris; begin
  { Lit la position courante }
  LitSouris;

  with souris do begin
    { Ecrit les valeurs }
    AttendEcran;

    CacheCurseurSouris;
    Str (X:3,txt);     EcriVga ( 32,8*0, Txt,14,CoulFond);
    Str (Y:3,txt);     EcriVga (112,8*0, Txt,14,CoulFond);
    Str (PlusX:5,txt); EcriVga ( 88,8*1, Txt,14,CoulFond);
    Str (PlusY:5,txt); EcriVga (186,8*1, Txt,14,CoulFond);
    EcriVga (11*8,8*2,OuiNon[Ord(b1)],14,CoulFond);
    if 1<Souris.NbrBouton then EcriVga (11*8,8*3,OuiNon[Ord(b2)],14,CoulFond);
    if 2<Souris.NbrBouton then EcriVga (11*8,8*4,OuiNon[Ord(b3)],14,CoulFond);
    AfficheCurseurSouris;

    { Bouton 1 : Change le curseur }
    if b1 then begin
      CacheCurseurSouris;

      if CurActif=3 then begin
        ReinitDriverSouris;
        DeplaceSouris (X,Y);
      end else ChangeCurseurSouris (NouvCur[CurActif]);

      if CurActif=3 then CurActif := 0 else inc (CurActif);
      AfficheCurseurSouris;
      AttendBoutonSouris (1);
    end;
  end; { de 'with Souris do' }
end;

procedure Init; var txt: String; begin
  ModeVga256; EffaceEcran (CoulFond);

  txt := DetectSouris;
  if txt<>'' then
    StopProgram ('l''initialisation de la souris',txt);

  InitDriverSouris (320,200);

  with Souris do begin
    SensibiliteSouris := 50;
    SeuilAccelSouris := 10;
    ChangeSensibilite (+0);
  end;

  CurActif := 0;

  EcriTsp (0,8*0,'X :     - Y :'         ,15);
  EcriTsp (0,8*1,'Relatif X :      - Y :',15);
  EcriTsp (0,8*2,'Bouton 1 :'            ,15);
  if 1<Souris.NbrBouton then EcriTsp (0,8*3,'Bouton 2 :'            ,15);
  if 2<Souris.NbrBouton then EcriTsp (0,8*4,'Bouton 3 :'            ,15);
  EcriTsp (0,8*5,'Sensibilite :',15);

  EcriTsp (319-19*8,200-8*2,'Echape pour quitter',12);
  EcriTsp (319-25*8,200-8*1,'+/- Rgler la sensibilit',12);

  AfficheCurseurSouris;               { Affiche la souris }
end;

begin
  Init;

  repeat
    ActuSouris;

    if TouchPresse then with Souris do begin
      key := LitTouche;

      Case key of
      '+': ChangeSensibilite (+5);
      '-': ChangeSensibilite (-5);
      end;
    end;
  until key=_ECHAPE;

  CacheCurseurSouris;
  ModeTxt;
end.